summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorJim Meyering <jim@meyering.net>2006-10-14 05:20:27 +0000
committerJim Meyering <jim@meyering.net>2006-10-14 05:20:27 +0000
commit0dc7f789861bedfa74639b89be8c3c4e8b3b6490 (patch)
treea10e74951ace317aacfad47febcc83e566fa31d0
parent779168820b3a002ead47e2ad79e15ab68018fc0b (diff)
downloadcoreutils-0dc7f789861bedfa74639b89be8c3c4e8b3b6490.tar.xz
* NEWS: cp -r --backup dir1 dir2, would rename an existing dir1/dir2
to dir1/dir2~. * src/copy.c (copy_internal): Although we do create a backup of each destination directory when in move mode, don't do that when copying. Reported by Peter Breitenlohner, in <http://article.gmane.org/gmane.comp.gnu.core-utils.bugs/8616>. * tests/cp/backup-dir: New file. Test for the above.
-rw-r--r--ChangeLog10
-rw-r--r--NEWS3
-rw-r--r--src/copy.c8
-rwxr-xr-xtests/cp/backup-dir52
4 files changed, 72 insertions, 1 deletions
diff --git a/ChangeLog b/ChangeLog
index ddbe32258..65bd1cb83 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,13 @@
+2006-10-14 Jim Meyering <jim@meyering.net>
+
+ * NEWS: cp -r --backup dir1 dir2, would rename an existing dir1/dir2
+ to dir1/dir2~.
+ * src/copy.c (copy_internal): Although we do create a backup of each
+ destination directory when in move mode, don't do that when copying.
+ Reported by Peter Breitenlohner, in
+ <http://article.gmane.org/gmane.comp.gnu.core-utils.bugs/8616>.
+ * tests/cp/backup-dir: New file. Test for the above.
+
2006-10-13 Jim Meyering <jim@meyering.net>
More chown/chgrp dereferencing-related fixes.
diff --git a/NEWS b/NEWS
index e7195f6b3..5959960dd 100644
--- a/NEWS
+++ b/NEWS
@@ -9,6 +9,9 @@ GNU coreutils NEWS -*- outline -*-
--from=o:g (chown only). This bug was introduced with the switch to
gnulib's openat-based variant of fts, for coreutils-6.0.
+ cp --backup dir1 dir2, would rename an existing dir1/dir2 to dir1/dir2~.
+ This bug was introduced in coreutils-6.0.
+
With --force (-f), rm no longer fails for ENOTDIR.
For example, "rm -f existing-non-directory/anything" now exits
successfully, ignoring the error about a nonexistent file.
diff --git a/src/copy.c b/src/copy.c
index 2a85578a6..2f03599e5 100644
--- a/src/copy.c
+++ b/src/copy.c
@@ -1181,7 +1181,13 @@ copy_internal (char const *src_name, char const *dst_name,
if (x->backup_type != no_backups
/* Don't try to back up a destination if the last
component of src_name is "." or "..". */
- && ! dot_or_dotdot (last_component (src_name)))
+ && ! dot_or_dotdot (last_component (src_name))
+ /* Create a backup of each destination directory in move mode,
+ but not in copy mode. FIXME: it might make sense to add an
+ option to suppress backup creation also for move mode.
+ That would let one use mv to merge new content into an
+ existing hierarchy. */
+ && (x->move_mode || ! S_ISDIR (dst_sb.st_mode)))
{
char *tmp_backup = find_backup_file_name (dst_name,
x->backup_type);
diff --git a/tests/cp/backup-dir b/tests/cp/backup-dir
new file mode 100755
index 000000000..03bdfc43a
--- /dev/null
+++ b/tests/cp/backup-dir
@@ -0,0 +1,52 @@
+#!/bin/sh
+# Ensure that cp -b doesn't back up directories.
+
+# Copyright (C) 2006 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ cp --version
+fi
+
+. $srcdir/../envvar-check
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
+trap 'status=$?; cd $pwd; chmod -R u+rwx $t0; rm -rf $t0 && exit $status' 0
+trap '(exit $?); exit $?' 1 2 13 15
+
+framework_failure=0
+mkdir -p $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+mkdir x y || framework_failure=1
+
+if test $framework_failure = 1; then
+ echo "$0: failure in testing framework" 1>&2
+ (exit 1); exit 1
+fi
+
+fail=0
+
+cp -a x y || fail=1
+
+# This would mistakenly create a backup of y/x (y/x~) in coreutils-6.3.
+cp -ab x y || fail=1
+test -d y/x || fail=1
+test -d y/x~ && fail=1
+
+(exit $fail); exit $fail